﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using HeuristicLab.BackgroundProcessing;
using System.Windows;
using System.IO.Compression;
using System.IO;
using HeuristicLab.MainForm.WPF;
using HeuristicLab.MainForm;
using System.Windows.Input;

namespace HeuristicLab.OKB.Cockpit.Admin {
  public partial class TableOverview : UserControl, IAutoView, IOKBCockpitItem {

    public TableOverview() {
      InitializeComponent();
    }

    protected void OnClick(object sender, RoutedEventArgs args) {
      string tableName = ((Button)args.Source).Name;
      TableView tableView = null;
      if (Keyboard.Modifiers != ModifierKeys.Shift) {
       tableView = (TableView)
        MainFormManager.MainForm.Views
        .FirstOrDefault(v => v is TableView && ((TableView)v).TableName == tableName);
      }
      if (tableView == null)
        tableView = new TableView() { TableName = tableName };
      tableView.Show();
    }

    #region IView Members

    public string Caption {
      get { return "OKB Admin Main View"; }
      set { }
    }

    public event EventHandler CaptionChanged;

    public event EventHandler Changed;

    public virtual void Close() {
      MainFormManager.GetMainForm<WPFMainFormBase>().CloseView(this);
      IsShown = false;
    }

    public void Hide() {
      MainFormManager.GetMainForm<WPFMainFormBase>().HideView(this);
      IsShown = false;
    }

    public bool IsShown { get; protected set; }

    private bool readOnly = false;
    public bool ReadOnly {
      get {
        return readOnly;
      }
      set {
        if (value == readOnly) return;
        readOnly = value;
        OnReadOnlyChanged();
      }
    }
    public event EventHandler ReadOnlyChanged;
    protected void OnReadOnlyChanged() {
      EventHandler handler = ReadOnlyChanged;
      if (handler != null)
        handler(this, EventArgs.Empty);
    }

    public void Show() {
      MainFormManager.GetMainForm<WPFMainFormBase>().ShowView(this);
      IsShown = true;
    }


    #endregion
  }
}
